local importPath=string.gsub(getfenv(1)._.Name,"%.Options","").."."
local resourcePath=string.gsub(importPath,"%.","/").."Resources/"
-- Options/Setup panel

OptionsPanel=Turbine.UI.Control()
OptionsPanel:SetMouseVisible(false);
OptionsPanel:SetSize(200,200);

OptionsPanel.Tabs=TabControl();
OptionsPanel.Tabs:SetParent(OptionsPanel)
OptionsPanel.Tabs:SetSize(OptionsPanel:GetSize());
OptionsPanel.Tabs:SetFont(settings.Font);

OptionsPanel.UITab=OptionsPanel.Tabs:AddTab(nil,Turbine.UI.Color(.0,.6,.0));
OptionsPanel.PanelTab=OptionsPanel.Tabs:AddTab(nil,Turbine.UI.Color(.6,.46,.02));
-- UI Tab controls
OptionsPanel.UIViewPort=Turbine.UI.Control();
OptionsPanel.UIViewPort:SetParent(OptionsPanel.UITab);
OptionsPanel.UIViewPort:SetSize(350,295);
--OptionsPanel.UIViewPort:SetBackColor(Turbine.UI.Color.Black)
OptionsPanel.UIVScroll=Turbine.UI.Lotro.ScrollBar();

OptionsPanel.UIVScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
OptionsPanel.UIVScroll:SetParent(OptionsPanel.UITab);
OptionsPanel.UIVScroll:SetPosition(OptionsPanel.PanelTab:GetWidth()-11,0);
OptionsPanel.UIVScroll:SetSize(10,OptionsPanel.PanelTab:GetHeight());
OptionsPanel.UIVScroll:SetVisible((OptionsPanel.UIViewPort:GetHeight()>OptionsPanel.PanelTab:GetHeight()));
OptionsPanel.UIVScroll.ValueChanged=function()
	OptionsPanel.UIViewPort:SetTop(0-OptionsPanel.UIVScroll:GetValue());
end

OptionsPanel.LangCaption=Turbine.UI.Label();
OptionsPanel.LangCaption:SetParent(OptionsPanel.UIViewPort);
OptionsPanel.LangCaption:SetFont(settings.Font);
OptionsPanel.LangCaption:SetSize(100,20);
OptionsPanel.LangCaption:SetPosition(10,10);
OptionsPanel.LangSel=DropDownList();
OptionsPanel.LangSel:SetParent(OptionsPanel.UIViewPort);
OptionsPanel.LangSel:SetFont(settings.Font);
OptionsPanel.LangSel:SetSize(230,20);
OptionsPanel.LangSel:SetPosition(OptionsPanel.LangCaption:GetLeft()+OptionsPanel.LangCaption:GetWidth()+5,OptionsPanel.LangCaption:GetTop());
for k,v in pairs(Resource) do
	OptionsPanel.LangSel:AddItem(v[1],k);
end
OptionsPanel.LangSel:SetSelectedIndex(language);
OptionsPanel.LangSel.SelectedIndexChanged=function()
	language=OptionsPanel.LangSel:GetSelectedIndex();
	mainWindow:SetLanguage();
end
OptionsPanel.LangSel:SetZOrder(1);

OptionsPanel.LoadMinimized=Turbine.UI.Lotro.CheckBox();
OptionsPanel.LoadMinimized:SetParent(OptionsPanel.UIViewPort);
OptionsPanel.LoadMinimized:SetFont(settings.Font);
OptionsPanel.LoadMinimized:SetSize(230,20);
OptionsPanel.LoadMinimized:SetPosition(OptionsPanel.LangSel:GetLeft(),OptionsPanel.LangCaption:GetTop()+OptionsPanel.LangCaption:GetHeight()+5);
OptionsPanel.LoadMinimized:SetChecked(settings.LoadMinimized);
OptionsPanel.LoadMinimized.CheckedChanged=function()
	settings.LoadMinimized=OptionsPanel.LoadMinimized:IsChecked();
end

OptionsPanel.ShowIcon=Turbine.UI.Lotro.CheckBox();
OptionsPanel.ShowIcon:SetParent(OptionsPanel.UIViewPort);
OptionsPanel.ShowIcon:SetFont(settings.Font);
OptionsPanel.ShowIcon:SetSize(230,20);
OptionsPanel.ShowIcon:SetPosition(OptionsPanel.LangSel:GetLeft(),OptionsPanel.LoadMinimized:GetTop()+OptionsPanel.LoadMinimized:GetHeight()+5);
OptionsPanel.ShowIcon:SetChecked(settings.ShowIcon);
OptionsPanel.ShowIcon.CheckedChanged=function()
	settings.ShowIcon=OptionsPanel.ShowIcon:IsChecked();
	OptionsPanel.LeftCaption:SetVisible(settings.ShowIcon);
	OptionsPanel.LeftValue:SetVisible(settings.ShowIcon);
	OptionsPanel.TopCaption:SetVisible(settings.ShowIcon);
	OptionsPanel.TopValue:SetVisible(settings.ShowIcon);
end

OptionsPanel.LeftCaption=Turbine.UI.Label();
OptionsPanel.LeftCaption:SetParent(OptionsPanel.UIViewPort);
OptionsPanel.LeftCaption:SetFont(settings.Font);
OptionsPanel.LeftCaption:SetSize(60,20);
OptionsPanel.LeftCaption:SetPosition(100,OptionsPanel.ShowIcon:GetTop()+OptionsPanel.ShowIcon:GetHeight()+5);
OptionsPanel.LeftCaption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
OptionsPanel.LeftCaption:SetVisible(settings.ShowIcon);
OptionsPanel.LeftValue=Turbine.UI.Lotro.TextBox();
OptionsPanel.LeftValue:SetParent(OptionsPanel.UIViewPort);
OptionsPanel.LeftValue:SetFont(settings.Font);
OptionsPanel.LeftValue:SetSize(50,20);
OptionsPanel.LeftValue:SetPosition(OptionsPanel.LeftCaption:GetLeft()+OptionsPanel.LeftCaption:GetWidth()+5,OptionsPanel.LeftCaption:GetTop());
OptionsPanel.LeftValue:SetVisible(settings.ShowIcon);
OptionsPanel.LeftValue:SetMultiline(false);
OptionsPanel.LeftValue:SetText(iconWindow:GetLeft());
OptionsPanel.LeftValue.EnterPressed=function()
	local tmpLeft=tonumber(OptionsPanel.LeftValue:GetText());
	if tmpLeft==nil or tmpLeft<0 then tmpLeft=0 end
	if tmpLeft>displayHeight-iconWindow:GetWidth() then tmpLeft=displayHeight()-iconWindow:GetWidth() end
	tmpLeft=math.floor(tmpLeft);
	OptionsPanel.LeftValue:SetText(tostring(tmpLeft));
	iconWindow:SetLeft(tmpLeft);
end
OptionsPanel.LeftValue.FocusLost=function()
	OptionsPanel.LeftValue.EnterPressed();
	OptionsPanel.LeftValue:SetWantsKeyEvents(false);
end
OptionsPanel.LeftValue.KeyDown=function(sender,args)
	if args.Action==162 then
		OptionsPanel.LeftValue.EnterPressed();
	end
end
OptionsPanel.LeftValue.FocusGained=function()
	OptionsPanel.LeftValue:SetWantsKeyEvents(true);
end
OptionsPanel.TopCaption=Turbine.UI.Label();
OptionsPanel.TopCaption:SetParent(OptionsPanel.UIViewPort);
OptionsPanel.TopCaption:SetFont(settings.Font);
OptionsPanel.TopCaption:SetSize(60,20);
OptionsPanel.TopCaption:SetPosition(OptionsPanel.LeftValue:GetLeft()+OptionsPanel.LeftValue:GetWidth()+10,OptionsPanel.LeftCaption:GetTop());
OptionsPanel.TopCaption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
OptionsPanel.TopCaption:SetVisible(settings.ShowIcon);
OptionsPanel.TopValue=Turbine.UI.Lotro.TextBox();
OptionsPanel.TopValue:SetParent(OptionsPanel.UIViewPort);
OptionsPanel.TopValue:SetFont(settings.Font);
OptionsPanel.TopValue:SetSize(50,20);
OptionsPanel.TopValue:SetPosition(OptionsPanel.TopCaption:GetLeft()+OptionsPanel.TopCaption:GetWidth()+5,OptionsPanel.TopCaption:GetTop());
OptionsPanel.TopValue:SetVisible(settings.ShowIcon);
OptionsPanel.TopValue:SetMultiline(false);
OptionsPanel.TopValue:SetText(iconWindow:GetTop());
OptionsPanel.TopValue.EnterPressed=function()
	local tmpTop=tonumber(OptionsPanel.TopValue:GetText());
	if tmpTop==nil or tmpTop<0 then tmpTop=0 end
	if tmpTop>displayHeight-iconWindow:GetWidth() then tmpTop=displayHeight()-iconWindow:GetWidth() end
	tmpTop=math.floor(tmpTop);
	OptionsPanel.TopValue:SetText(tostring(tmpTop));
	iconWindow:SetTop(tmpTop);
end
OptionsPanel.TopValue.FocusLost=function()
	OptionsPanel.TopValue.EnterPressed();
	OptionsPanel.TopValue:SetWantsKeyEvents(false);
end
OptionsPanel.TopValue.KeyDown=function(sender,args)
	if args.Action==162 then
		OptionsPanel.TopValue.EnterPressed();
	end
end
OptionsPanel.TopValue.FocusGained=function()
	OptionsPanel.TopValue:SetWantsKeyEvents(true);
end

OptionsPanel.UseMiniIcon=Turbine.UI.Lotro.CheckBox();
OptionsPanel.UseMiniIcon:SetParent(OptionsPanel.UIViewPort);
OptionsPanel.UseMiniIcon:SetFont(settings.Font);
OptionsPanel.UseMiniIcon:SetSize(230,20);
OptionsPanel.UseMiniIcon:SetPosition(OptionsPanel.LangSel:GetLeft(),OptionsPanel.TopCaption:GetTop()+OptionsPanel.TopCaption:GetHeight()+5);
OptionsPanel.UseMiniIcon:SetChecked(settings.UseMiniIcon);
OptionsPanel.UseMiniIcon.CheckedChanged=function()
	settings.UseMiniIcon=OptionsPanel.UseMiniIcon:IsChecked();
	if settings.UseMiniIcon then
		iconWindow.UpImage=resourcePath.."mini_icon.tga"
		iconWindow.HoverImage=resourcePath.."mini_hover.tga"
		iconWindow.MoveImage=resourcePath.."mini_drag.tga"
		iconWindow.FlashImage=resourcePath.."mini_border.tga"
	else
		iconWindow.UpImage=resourcePath.."icon_up.jpg"
		iconWindow.HoverImage=resourcePath.."icon_down.jpg"
		iconWindow.MoveImage=resourcePath.."icon_drag.jpg"
		iconWindow.FlashImage=resourcePath.."icon_border.tga"
	end
	iconWindow:SetBackground(iconWindow.UpImage);
end

OptionsPanel.TrimCaption=Turbine.UI.Label();
OptionsPanel.TrimCaption:SetParent(OptionsPanel.UIViewPort);
OptionsPanel.TrimCaption:SetFont(settings.Font);
OptionsPanel.TrimCaption:SetSize(100,20);
OptionsPanel.TrimCaption:SetPosition(10,OptionsPanel.UseMiniIcon:GetTop()+OptionsPanel.UseMiniIcon:GetHeight()+10);
OptionsPanel.TrimColor=ColorPicker();
OptionsPanel.TrimColor:SetParent(OptionsPanel.UIViewPort);
OptionsPanel.TrimColor:SetPosition(OptionsPanel.LangSel:GetLeft(),OptionsPanel.TrimCaption:GetTop());
OptionsPanel.TrimColor:SetColor(settings.TrimColor);
OptionsPanel.TrimColor.ColorChanged=function()
	settings.TrimColor=OptionsPanel.TrimColor:GetColor();
	mainWindow:SetColors();
end

OptionsPanel.BackCaption=Turbine.UI.Label();
OptionsPanel.BackCaption:SetParent(OptionsPanel.UIViewPort);
OptionsPanel.BackCaption:SetFont(settings.Font);
OptionsPanel.BackCaption:SetSize(100,20);
OptionsPanel.BackCaption:SetPosition(10,OptionsPanel.TrimCaption:GetTop()+OptionsPanel.TrimCaption:GetHeight()+5);
OptionsPanel.BackColor=ColorPicker();
OptionsPanel.BackColor:SetParent(OptionsPanel.UIViewPort);
OptionsPanel.BackColor:SetPosition(OptionsPanel.LangSel:GetLeft(),OptionsPanel.BackCaption:GetTop());
OptionsPanel.BackColor:SetColor(settings.BackColor);
OptionsPanel.BackColor.ColorChanged=function()
	settings.BackColor=OptionsPanel.BackColor:GetColor();
	mainWindow:SetColors();
end

OptionsPanel.TextCaption=Turbine.UI.Label();
OptionsPanel.TextCaption:SetParent(OptionsPanel.UIViewPort);
OptionsPanel.TextCaption:SetFont(settings.Font);
OptionsPanel.TextCaption:SetSize(100,20);
OptionsPanel.TextCaption:SetPosition(10,OptionsPanel.BackCaption:GetTop()+OptionsPanel.BackCaption:GetHeight()+5);
OptionsPanel.TextColor=ColorPicker();
OptionsPanel.TextColor:SetParent(OptionsPanel.UIViewPort);
OptionsPanel.TextColor:SetPosition(OptionsPanel.LangSel:GetLeft(),OptionsPanel.TextCaption:GetTop());
OptionsPanel.TextColor:SetColor(settings.ForeColor);
OptionsPanel.TextColor.ColorChanged=function()
	settings.ForeColor=OptionsPanel.TextColor:GetColor();
	mainWindow:SetColors();
end

OptionsPanel.HeadingsCaption=Turbine.UI.Label();
OptionsPanel.HeadingsCaption:SetParent(OptionsPanel.UIViewPort);
OptionsPanel.HeadingsCaption:SetFont(settings.Font);
OptionsPanel.HeadingsCaption:SetSize(100,20);
OptionsPanel.HeadingsCaption:SetPosition(10,OptionsPanel.TextCaption:GetTop()+OptionsPanel.TextCaption:GetHeight()+5);
OptionsPanel.HeadingsColor=ColorPicker();
OptionsPanel.HeadingsColor:SetParent(OptionsPanel.UIViewPort);
OptionsPanel.HeadingsColor:SetPosition(OptionsPanel.LangSel:GetLeft(),OptionsPanel.HeadingsCaption:GetTop());
OptionsPanel.HeadingsColor:SetColor(settings.HeadingsColor);
OptionsPanel.HeadingsColor.ColorChanged=function()
	settings.HeadingsColor=OptionsPanel.HeadingsColor:GetColor();
	mainWindow:SetColors();
end

OptionsPanel.ListTextCaption=Turbine.UI.Label();
OptionsPanel.ListTextCaption:SetParent(OptionsPanel.UIViewPort);
OptionsPanel.ListTextCaption:SetFont(settings.Font);
OptionsPanel.ListTextCaption:SetSize(100,20);
OptionsPanel.ListTextCaption:SetPosition(10,OptionsPanel.HeadingsCaption:GetTop()+OptionsPanel.HeadingsCaption:GetHeight()+5);
OptionsPanel.ListTextColor=ColorPicker();
OptionsPanel.ListTextColor:SetParent(OptionsPanel.UIViewPort);
OptionsPanel.ListTextColor:SetPosition(OptionsPanel.LangSel:GetLeft(),OptionsPanel.ListTextCaption:GetTop());
OptionsPanel.ListTextColor:SetColor(settings.ListTextColor);
OptionsPanel.ListTextColor.ColorChanged=function()
	settings.ListTextColor=OptionsPanel.ListTextColor:GetColor();
	mainWindow:SetColors();
end

OptionsPanel.DefaultColors=Turbine.UI.Lotro.Button();
OptionsPanel.DefaultColors:SetParent(OptionsPanel.UIViewPort);
OptionsPanel.DefaultColors:SetFont(settings.Font);
OptionsPanel.DefaultColors:SetSize(200,20);
OptionsPanel.DefaultColors:SetPosition((OptionsPanel.UIViewPort:GetWidth()-OptionsPanel.DefaultColors:GetWidth())/2,OptionsPanel.ListTextCaption:GetTop()+OptionsPanel.ListTextCaption:GetHeight()+5);
OptionsPanel.DefaultColors.Click=function()
	settings.ErrorColor=Turbine.UI.Color(1,0,0);
	
	OptionsPanel.TrimColor:SetColor(Turbine.UI.Color(.4,.4,.5));
	OptionsPanel.BackColor:SetColor(Turbine.UI.Color(.05,.05,.05));
	OptionsPanel.TextColor:SetColor(Turbine.UI.Color(1,.9,.5));
	OptionsPanel.HeadingsColor:SetColor(Turbine.UI.Color(1,1,1));
	OptionsPanel.ListTextColor:SetColor(Turbine.UI.Color(1,1,1));
	mainWindow:SetColors();
end

-- Panel Tab controls

OptionsPanel.DefPanelCaption=Turbine.UI.Label();
OptionsPanel.DefPanelCaption:SetParent(OptionsPanel.PanelTab);
OptionsPanel.DefPanelCaption:SetFont(settings.Font);
OptionsPanel.DefPanelCaption:SetSize(100,20);
OptionsPanel.DefPanelCaption:SetPosition(10,10);
OptionsPanel.DefPanelSel=DropDownList();
OptionsPanel.DefPanelSel:SetParent(OptionsPanel.PanelTab);
OptionsPanel.DefPanelSel:SetFont(settings.Font);
OptionsPanel.DefPanelSel:SetSize(230,20);
OptionsPanel.DefPanelSel:SetBackColor(settings.BackColor);
OptionsPanel.DefPanelSel:SetCurrentBackColor(settings.BackColor);
OptionsPanel.DefPanelSel:SetBorderColor(settings.TrimColor);
OptionsPanel.DefPanelSel:SetPosition(OptionsPanel.DefPanelCaption:GetLeft()+OptionsPanel.DefPanelCaption:GetWidth()+5,OptionsPanel.DefPanelCaption:GetTop());
local tmpIndex=1;
OptionsPanel.DefPanelSel:AddItem(Resource[language][29],"Most Recent")
OptionsPanel.DefPanelSel:AddItem(Resource[language][30],"First Available")
if settings.DefaultPanel=="First Available" then tmpIndex=2 end
for k,v in ipairs(settings.Panels) do
	local tmpName=Resource[language][v.StringID];
	if tmpName==nil then
		tmpName=v.Name
	end
	OptionsPanel.DefPanelSel:AddItem(tmpName,v.Name);
	if settings.DefaultPanel==v.Name then tmpIndex=k+2 end
end
OptionsPanel.DefPanelSel:SetSelectedIndex(tmpIndex);
OptionsPanel.DefPanelSel:SetZOrder(1);

OptionsPanel.NameCaption=Turbine.UI.Label();
OptionsPanel.NameCaption:SetParent(OptionsPanel.PanelTab);
OptionsPanel.NameCaption:SetFont(settings.Font);
OptionsPanel.NameCaption:SetSize(180,20);
OptionsPanel.NameCaption:SetPosition(0,35);
OptionsPanel.NameCaption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);

OptionsPanel.LoadCaption=Turbine.UI.Label();
OptionsPanel.LoadCaption:SetParent(OptionsPanel.PanelTab);
OptionsPanel.LoadCaption:SetFont(settings.Font);
OptionsPanel.LoadCaption:SetSize(70,20);
OptionsPanel.LoadCaption:SetPosition(180,35);
OptionsPanel.LoadCaption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);

OptionsPanel.ShowCaption=Turbine.UI.Label();
OptionsPanel.ShowCaption:SetParent(OptionsPanel.PanelTab);
OptionsPanel.ShowCaption:SetFont(settings.Font);
OptionsPanel.ShowCaption:SetSize(70,20);
OptionsPanel.ShowCaption:SetPosition(250,35);
OptionsPanel.ShowCaption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);

OptionsPanel.PanelList=Turbine.UI.ListBox();
OptionsPanel.PanelList:SetParent(OptionsPanel.PanelTab);
OptionsPanel.PanelList:SetPosition(0,OptionsPanel.NameCaption:GetTop()+OptionsPanel.NameCaption:GetHeight()+5);
OptionsPanel.PanelList:SetSize(OptionsPanel:GetWidth()-10,OptionsPanel:GetHeight()-OptionsPanel.PanelList:GetTop());
OptionsPanel.PanelList:SetBackColor(Turbine.UI.Color.Black);
OptionsPanel.PanelListVScroll=Turbine.UI.Lotro.ScrollBar();
OptionsPanel.PanelListVScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
OptionsPanel.PanelListVScroll:SetParent(OptionsPanel.PanelTab);
OptionsPanel.PanelListVScroll:SetBackColor(backColor);
OptionsPanel.PanelListVScroll:SetPosition(OptionsPanel.PanelList:GetWidth(),OptionsPanel.PanelList:GetTop());
OptionsPanel.PanelListVScroll:SetSize(10,OptionsPanel.PanelList:GetHeight());
OptionsPanel.PanelList:SetVerticalScrollBar(OptionsPanel.PanelListVScroll);


function LoadPanelList()
	local rowFlag=false;
	for k,v in ipairs(settings.Panels) do
		tmpRow=Turbine.UI.Control();
		tmpRow.Index=k;
		tmpRow:SetParent(OptionsPanel.PanelList);
		if v.Name=="Options" then
			tmpRow:SetSize(300,0);
		else
			tmpRow:SetSize(300,20);
		end
		tmpRow.Name=Turbine.UI.Label();
		tmpRow.Name:SetParent(tmpRow);
		tmpRow.Name:SetSize(180,20);
		tmpRow.Name:SetFont(Turbine.UI.Lotro.Verdana18)
		local Text=Resource[language][v.StringID]
		if Text==nil then
			Text=v.Name;
		end
		tmpRow.Name:SetText(Text);
		tmpRow.Load=Turbine.UI.Lotro.CheckBox();
		tmpRow.Load:SetParent(tmpRow);
		tmpRow.Load:SetSize(20,20);
		tmpRow.Load:SetPosition(205,2);
		tmpRow.Load:SetChecked(v.Load);
		tmpRow.Load.CheckedChanged=function(sender)
			sender:GetParent().Show:SetVisible(sender:IsChecked());
		end
		tmpRow.Show=Turbine.UI.Lotro.CheckBox();
		tmpRow.Show:SetParent(tmpRow);
		tmpRow.Show:SetSize(20,20);
		tmpRow.Show:SetPosition(275,2);
		tmpRow.Show:SetChecked(v.Show);
		tmpRow.Show:SetVisible(v.Load);
		if rowFlag then
			tmpRow:SetBackColor(Turbine.UI.Color(.05,.05,.05));
		else
			tmpRow:SetBackColor(Turbine.UI.Color(0,0,0));
		end
		if v.Name~="Options" then
			rowFlag=not rowFlag;
		end
		OptionsPanel.PanelList:AddItem(tmpRow);
	end
end
LoadPanelList()

OptionsPanel.PanelsApply=Turbine.UI.Lotro.Button();
OptionsPanel.PanelsApply:SetParent(OptionsPanel.PanelTab);
OptionsPanel.PanelsApply:SetFont(settings.Font);
OptionsPanel.PanelsApply:SetSize(200,20);
OptionsPanel.PanelsApply:SetPosition((OptionsPanel.PanelTab:GetWidth()-OptionsPanel.PanelsApply:GetWidth())/2,OptionsPanel.PanelList:GetTop()+OptionsPanel.PanelList:GetHeight());
OptionsPanel.PanelsApply.Click=function()
	Turbine.Shell.WriteLine("Updating Panel Settings")
	settings.DefaultPanel=OptionsPanel.DefPanelSel:GetValue();
	-- update the settings
	local tmpIndex;
	for tmpIndex=1,OptionsPanel.PanelList:GetItemCount() do
		local tmpRow=OptionsPanel.PanelList:GetItem(tmpIndex);
		settings.Panels[tmpRow.Index].Load=tmpRow.Load:IsChecked();
		settings.Panels[tmpRow.Index].Show=tmpRow.Show:IsChecked();
	end
	Turbine.PluginManager.LoadPlugin("AltViewerReloader");
end

OptionsPanel.RemoveCallbacks=function()
end
OptionsPanel.RemoveCharacter=function(characterName)
end
OptionsPanel.SizeChanged=function(sender,args)
	local newWidth,newHeight=mainWindow.PanelBack:GetSize();
	Turbine.UI.Control.SetSize(OptionsPanel,newWidth,newHeight);
	OptionsPanel.Tabs:SetSize(newWidth,newHeight);

	OptionsPanel.UIViewPort:SetWidth(OptionsPanel.UITab:GetWidth()-11)
	OptionsPanel.DefaultColors:SetPosition((OptionsPanel.UIViewPort:GetWidth()-OptionsPanel.DefaultColors:GetWidth())/2,OptionsPanel.ListTextCaption:GetTop()+OptionsPanel.ListTextCaption:GetHeight()+5);
	OptionsPanel.UIVScroll:SetLeft(OptionsPanel.PanelTab:GetWidth()-10);
	OptionsPanel.UIVScroll:SetHeight(OptionsPanel.PanelTab:GetHeight());
	local oldScroll=0;
	if OptionsPanel.UIVScroll:IsVisible() then
		oldScroll=OptionsPanel.UIVScroll:GetValue()/OptionsPanel.UIVScroll:GetMaximum();
	end
	OptionsPanel.UIVScroll:SetVisible((OptionsPanel.UIViewPort:GetHeight()>OptionsPanel.PanelTab:GetHeight()));
	if OptionsPanel.UIVScroll:IsVisible() then
		OptionsPanel.UIVScroll:SetMaximum(OptionsPanel.UIViewPort:GetHeight()-OptionsPanel.UITab:GetHeight());
		OptionsPanel.UIVScroll:SetValue(oldScroll*OptionsPanel.UIVScroll:GetMaximum());
	else
		OptionsPanel.UIVScroll:SetValue(0);
		OptionsPanel.UIViewPort:SetTop(0);
	end

	OptionsPanel.PanelList:SetSize(320,OptionsPanel.PanelTab:GetHeight()-OptionsPanel.PanelList:GetTop()-35);
	OptionsPanel.PanelListVScroll:SetLeft(OptionsPanel.PanelList:GetWidth());
	OptionsPanel.PanelListVScroll:SetHeight(OptionsPanel.PanelList:GetHeight());
	OptionsPanel.PanelsApply:SetPosition((OptionsPanel.PanelTab:GetWidth()-OptionsPanel.PanelsApply:GetWidth())/2,OptionsPanel.PanelList:GetTop()+OptionsPanel.PanelList:GetHeight()+5);
end
OptionsPanel.SetLanguage=function()
	OptionsPanel.UITab:SetText(Resource[language][16]);
	OptionsPanel.PanelTab:SetText(Resource[language][17]);
	OptionsPanel.LangCaption:SetText(Resource[language][18]..":");
	OptionsPanel.LoadMinimized:SetText(Resource[language][26]);
	OptionsPanel.ShowIcon:SetText(Resource[language][27]);
	OptionsPanel.LeftCaption:SetText(Resource[language][31]..":");
	OptionsPanel.TopCaption:SetText(Resource[language][32]..":");
	OptionsPanel.UseMiniIcon:SetText(Resource[language][33]);
	OptionsPanel.TrimCaption:SetText(Resource[language][34]..":");
	OptionsPanel.BackCaption:SetText(Resource[language][35]..":");
	OptionsPanel.TextCaption:SetText(Resource[language][36]..":");
	OptionsPanel.HeadingsCaption:SetText(Resource[language][37]..":");
	OptionsPanel.ListTextCaption:SetText(Resource[language][38]..":");
	OptionsPanel.DefaultColors:SetText(Resource[language][39]);
	OptionsPanel.DefPanelCaption:SetText(Resource[language][28]..":");
	OptionsPanel.NameCaption:SetText(Resource[language][20]);
	OptionsPanel.LoadCaption:SetText(Resource[language][21]);
	OptionsPanel.ShowCaption:SetText(Resource[language][22]);
	OptionsPanel.PanelsApply:SetText(Resource[language][19]);

	OptionsPanel.DefPanelSel.ListData:GetItem(1):SetText(Resource[language][29])
	OptionsPanel.DefPanelSel.ListData:GetItem(2):SetText(Resource[language][30])
	for k,v in ipairs(settings.Panels) do
		local tmpName=Resource[language][v.StringID];
		if tmpName==nil then
			tmpName=v.Name
		end
		OptionsPanel.DefPanelSel.ListData:GetItem(k+2):SetText(tmpName);
	end
	OptionsPanel.DefPanelSel.CurrentValue:SetText(OptionsPanel.DefPanelSel.ListData:GetItem(OptionsPanel.DefPanelSel:GetSelectedIndex()):GetText());
end
OptionsPanel.SetColors=function()
	OptionsPanel.LangSel:SetBorderColor(settings.TrimColor);
	OptionsPanel.LangSel:SetTextColor(settings.ListTextColor);
	OptionsPanel:SetBackColor(settings.BackColor);
	OptionsPanel.LangSel:SetBackColor(settings.BackColor);
	OptionsPanel.LangSel:SetCurrentBackColor(settings.BackColor);
	OptionsPanel.LangCaption:SetForeColor(settings.ForeColor);
	OptionsPanel.LoadMinimized:SetForeColor(settings.ForeColor);
	OptionsPanel.ShowIcon:SetForeColor(settings.ForeColor);
	OptionsPanel.LeftCaption:SetForeColor(settings.ForeColor);
	OptionsPanel.TopCaption:SetForeColor(settings.ForeColor);
	OptionsPanel.UseMiniIcon:SetForeColor(settings.ForeColor);
	OptionsPanel.TrimCaption:SetForeColor(settings.ForeColor);
	OptionsPanel.BackCaption:SetForeColor(settings.ForeColor);
	OptionsPanel.TextCaption:SetForeColor(settings.ForeColor);
	OptionsPanel.HeadingsCaption:SetForeColor(settings.ForeColor);
	OptionsPanel.ListTextCaption:SetForeColor(settings.ForeColor);
	OptionsPanel.DefPanelCaption:SetForeColor(settings.ForeColor);
	OptionsPanel.DefPanelSel:SetTextColor(settings.ListTextColor);
	OptionsPanel.NameCaption:SetForeColor(settings.ForeColor);
	OptionsPanel.LoadCaption:SetForeColor(settings.ForeColor);
	OptionsPanel.ShowCaption:SetForeColor(settings.ForeColor);
	for tmpIndex=1,OptionsPanel.PanelList:GetItemCount() do
		OptionsPanel.PanelList:GetItem(tmpIndex).Name:SetForeColor(settings.ListTextColor);
	end
end
